#include <iom8v.h>
#include <macros.h>
#include "var.h"

void twi_init(void);// TWI
void WR_DS1307(unsigned char address, unsigned char wr_data);//    DS1307
unsigned char RE_DS1307(unsigned char address);//    DS1307
//void WR_DS1307_MAS(unsigned char address, unsigned char *array, unsigned char size);//    DS1307
void RE_DS1307_MAS(unsigned char address, unsigned char *array, unsigned char size);//    DS1307
void update_time(void);

//TWI initialize
// bit rate:0
void twi_init(void)// TWI
{
 TWCR= 0X00;
 TWBR= 0x08;
 TWSR= 0x02;
 TWAR= 0x00;
}

void WR_DS1307(unsigned char address, unsigned char wr_data){
	twi_init();
	CLI(); //disable all interrupts
	TWCR = 0xE4;//
	while(1) if((TWCR&0x80)&&((TWSR&0xFC) == 0x08)) break;// 
	TWDR = 0xD0;//SLA+W
	TWCR = 0xC4;//  " "
	while(1){
		if((TWCR&0x80)&&((TWSR&0xFC) == 0x18)){
			break;//   SLA+W   
		}
	}
	TWDR = address;// 
	TWCR = 0xC4;// 
	while(1){
		if((TWCR&0x80)&&((TWSR&0xFC) == 0x28)){
			break;//      
		}
	}
	TWDR = wr_data;// 
	TWCR = 0xC4;// 
	while(1){
		if((TWCR&0x80)&&((TWSR&0xFC) == 0x28)){
			break;//      
		}
	}
	TWCR = 0xD4;//
	SEI(); //re-enable interrupts
}

unsigned char RE_DS1307(unsigned char address){
	unsigned char data_TWDR;
	twi_init();
	CLI(); //disable all interrupts
	TWCR = 0xE4;//
	while(1) if((TWCR&0x80)&&((TWSR&0xFC) == 0x08)) break;// 
	TWDR = 0xD0;//SLA+W
	TWCR = 0xC4;//  " "
	while(1){
		if((TWCR&0x80)&&((TWSR&0xFC) == 0x18)){
			break;//   SLA+W   
		}
	}
	TWDR = address;// 
	TWCR = 0xC4;// 
	while(1){
		if((TWCR&0x80)&&((TWSR&0xFC) == 0x28)){
			break;//      
		}
	}
	TWCR = 0xE4;//
	while(1) if((TWCR&0x80)&&((TWSR&0xFC) == 0x10)) break;// 
	TWDR = 0xD1;//SLA+R
	TWCR = 0xC4;//  " "
	while(1){
		if((TWCR&0x80)&&((TWSR&0xFC) == 0x40)){
			break;//   SLA+R   
		}
	}
	TWCR = 0x84;// 
	while(1){
		if((TWCR&0x80)&&((TWSR&0xFC) == 0x58)){
			break;//      
		}
	}
	data_TWDR = TWDR;// 
	TWCR = 0xD4;//
	SEI(); //re-enable interrupts
	return data_TWDR;
}

/*void WR_DS1307_MAS(unsigned char address, unsigned char *array, unsigned char size){
	unsigned int WR_DS1307_MAS_i = 0;
	twi_init();
	TWCR = 0xE4;//
	while(1) if((TWCR&0x80)&&((TWSR&0xFC) == 0x08)) break;// 
	TWDR = 0xD0;//SLA+W
	TWCR = 0xC4;//  " "
	while(1){
		if((TWCR&0x80)&&((TWSR&0xFC) == 0x18)){
			break;//   SLA+W   
		}
	}
	TWDR = address;//  (8  )
	TWCR = 0xC4;// 
	while(1){
		if((TWCR&0x80)&&((TWSR&0xFC) == 0x28)){
			break;//      
		}
	}
	for(WR_DS1307_MAS_i = 0; WR_DS1307_MAS_i < size; WR_DS1307_MAS_i++){
		TWDR = array[WR_DS1307_MAS_i];// 
		TWCR = 0xC4;// 
		while(1){
			if((TWCR&0x80)&&((TWSR&0xFC) == 0x28)){
				break;//      
			}
		}
	}
	TWCR = 0xD4;//
}*/

void RE_DS1307_MAS(unsigned char address, unsigned char *array, unsigned char size){
	unsigned int RE_DS1307_MAS_i = 0;
	twi_init();
	CLI(); //disable all interrupts
	TWCR = 0xE4;//
	while(1)
	{
	 	if((TWCR&0x80)&&((TWSR&0xFC) == 0x08)) break;// 
		//WDR();
	}
	TWDR = 0xD0;//SLA+W
	TWCR = 0xC4;//  " "
	while(1){
		if((TWCR&0x80)&&((TWSR&0xFC) == 0x18)){
			break;//   SLA+W   
		}
		//WDR();
	}
	TWDR = address;//  (8  )
	TWCR = 0xC4;// 
	while(1){
		if((TWCR&0x80)&&((TWSR&0xFC) == 0x28)){
			break;//      
		}
		//WDR();
	}
	TWCR = 0xE4;//
	while(1) if((TWCR&0x80)&&((TWSR&0xFC) == 0x10)) break;// 
	TWDR = 0xD1;//SLA+R
	TWCR = 0xC4;//  " "
	while(1){
		if((TWCR&0x80)&&((TWSR&0xFC) == 0x40)){
			break;//   SLA+R   
		}
		//WDR();
	}
	for(RE_DS1307_MAS_i = 0; RE_DS1307_MAS_i < size; RE_DS1307_MAS_i++){
		if(RE_DS1307_MAS_i != (size-1)) TWCR = 0xC4;// 
		else TWCR = 0x84;// 
		while(1){
			if((TWCR&0x80)&&((TWSR&0xFC) == 0x50)&&(RE_DS1307_MAS_i != (size-1))){
				break;//      
			}
			if((TWCR&0x80)&&((TWSR&0xFC) == 0x58)&&(RE_DS1307_MAS_i == (size-1))){
				break;//      
			}
			//WDR();
		}
		array[RE_DS1307_MAS_i] = TWDR;// 
	}
	TWCR = 0xD4;//
	SEI(); //re-enable interrupts
}

void update_time(void)
{
 	RE_DS1307_MAS(0x00, mas_DS1307, 0x07);
	
	year_1 = (mas_DS1307[6] >> 4);
	year_2 = (mas_DS1307[6]&0x0F);
	
	
	mon_1 = ((mas_DS1307[5]&0x10) >> 4);
	mon_2 = (mas_DS1307[5]&0x0F);
	
	date_1 = ((mas_DS1307[4]&0x30) >> 4);
	date_2 = (mas_DS1307[4]&0x0F);
	
	day = mas_DS1307[3];
	
	hour_1 = ((mas_DS1307[2]&0x30) >> 4);
	hour_2 = (mas_DS1307[2]&0x0F);
	
	min_1 = (mas_DS1307[1] >> 4);
	min_2 = (mas_DS1307[1]&0x0F);
	
	sec_1 = ((mas_DS1307[0]&0x70) >> 4);
	sec_2 = (mas_DS1307[0]&0x0F);
}