#include <iom8v.h>
#include <macros.h>


int EEPROMwrite(int location, unsigned char byte)
{
	unsigned char oldSREG;
   
    while (EECR & 0x02){};                // Wait until any earlier write is done

	EEAR = location;

    EEDR = byte;

	oldSREG = SREG;
	SREG &= ~0x80;		// disable interrupt

    EECR |= 0x04;                       // Set MASTER WRITE enable
    EECR |= 0x02;                       // Set WRITE strobe

	SREG = oldSREG;
	
    return 0;                           // return Success.
                                        // Could be expanded so that
                                        // the routine checks that the address
                                        // is within the range of the chip.
}   

unsigned char EEPROMread(int location)
{
	while (EECR & 0x02){};                // Wait until any earlier write is done.
                                        // This is just a safety incase a write
                                        // was done and is not completed when
                                        // the read was called. If this test is
                                        // not done, the current write operation
                                        // will fail due to that the address or
                                        // data is changed.

	EEAR = location;
    
    EECR |= 0x01;                       // Set READ strobe
	
    return (EEDR);                      // Return byte
}


void EEPROMReadBytes(int addr, void *ptr,int size)
	{
	char *dst = ptr;

	while (size--)
		{
		*dst = EEPROMread(addr);
		addr++;
		dst++;
		}
	}


void EEPROMWriteBytes(int addr, void *ptr,int size)
	{
	char *src = ptr;

	while (size--)
		{
		EEPROMwrite(addr, *src);
		addr++;
		src++;
		}
	}
