	.module eeprom.c
	.area text(rom, con, rel)
	.dbfile D:\Documenti\Progetti\orologio\orologio_AVR_prog_v1.5\eeprom.c
	.dbfunc e EEPROMwrite _EEPROMwrite fI
;        oldSREG -> R20
;           byte -> R18
;       location -> R16,R17
	.even
_EEPROMwrite::
	rcall push_gset1
	.dbline -1
	.dbline 6
; #include <iom8v.h>
; #include <macros.h>
; 
; 
; int EEPROMwrite(int location, unsigned char byte)
; {
L2:
	.dbline 9
	.dbline 9
L3:
	.dbline 9
; 	unsigned char oldSREG;
;    
;     while (EECR & 0x02){};                // Wait until any earlier write is done
	sbic 0x1c,1
	rjmp L2
	.dbline 9
	.dbline 11
; 
; 	EEAR = location;
	out 0x1f,R17
	out 0x1e,R16
	.dbline 13
; 
;     EEDR = byte;
	out 0x1d,R18
	.dbline 15
; 
; 	oldSREG = SREG;
	in R20,0x3f
	.dbline 16
; 	SREG &= ~0x80;		// disable interrupt
	bclr 7
	.dbline 18
; 
;     EECR |= 0x04;                       // Set MASTER WRITE enable
	sbi 0x1c,2
	.dbline 19
;     EECR |= 0x02;                       // Set WRITE strobe
	sbi 0x1c,1
	.dbline 21
; 
; 	SREG = oldSREG;
	out 0x3f,R20
	.dbline 23
; 	
;     return 0;                           // return Success.
	clr R16
	clr R17
	.dbline -2
L1:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r oldSREG 20 c
	.dbsym r byte 18 c
	.dbsym r location 16 I
	.dbend
	.dbfunc e EEPROMread _EEPROMread fc
;       location -> R16,R17
	.even
_EEPROMread::
	.dbline -1
	.dbline 30
;                                         // Could be expanded so that
;                                         // the routine checks that the address
;                                         // is within the range of the chip.
; }   
; 
; unsigned char EEPROMread(int location)
; {
L6:
	.dbline 31
	.dbline 31
L7:
	.dbline 31
; 	while (EECR & 0x02){};                // Wait until any earlier write is done.
	sbic 0x1c,1
	rjmp L6
	.dbline 31
	.dbline 39
;                                         // This is just a safety incase a write
;                                         // was done and is not completed when
;                                         // the read was called. If this test is
;                                         // not done, the current write operation
;                                         // will fail due to that the address or
;                                         // data is changed.
; 
; 	EEAR = location;
	out 0x1f,R17
	out 0x1e,R16
	.dbline 41
;     
;     EECR |= 0x01;                       // Set READ strobe
	sbi 0x1c,0
	.dbline 43
; 	
;     return (EEDR);                      // Return byte
	in R16,0x1d
	.dbline -2
L5:
	.dbline 0 ; func end
	ret
	.dbsym r location 16 I
	.dbend
	.dbfunc e EEPROMReadBytes _EEPROMReadBytes fV
;            dst -> R20,R21
;           size -> R22,R23
;            ptr -> R12,R13
;           addr -> R10,R11
	.even
_EEPROMReadBytes::
	rcall push_gset4
	movw R12,R18
	movw R10,R16
	ldd R22,y+8
	ldd R23,y+9
	.dbline -1
	.dbline 48
; }
; 
; 
; void EEPROMReadBytes(int addr, void *ptr,int size)
; 	{
	.dbline 49
; 	char *dst = ptr;
	movw R20,R12
	rjmp L11
L10:
	.dbline 52
	.dbline 53
	movw R16,R10
	rcall _EEPROMread
	movw R30,R20
	std z+0,R16
	.dbline 54
	movw R24,R10
	adiw R24,1
	movw R10,R24
	.dbline 55
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 56
L11:
	.dbline 51
; 
; 	while (size--)
	movw R2,R22
	subi R22,1
	sbci R23,0
	tst R2
	brne L10
	tst R3
	brne L10
X0:
	.dbline -2
L9:
	rcall pop_gset4
	.dbline 0 ; func end
	ret
	.dbsym r dst 20 pc
	.dbsym r size 22 I
	.dbsym r ptr 12 pV
	.dbsym r addr 10 I
	.dbend
	.dbfunc e EEPROMWriteBytes _EEPROMWriteBytes fV
;            src -> R20,R21
;           size -> R22,R23
;            ptr -> R12,R13
;           addr -> R10,R11
	.even
_EEPROMWriteBytes::
	rcall push_gset4
	movw R12,R18
	movw R10,R16
	ldd R22,y+8
	ldd R23,y+9
	.dbline -1
	.dbline 61
; 		{
; 		*dst = EEPROMread(addr);
; 		addr++;
; 		dst++;
; 		}
; 	}
; 
; 
; void EEPROMWriteBytes(int addr, void *ptr,int size)
; 	{
	.dbline 62
; 	char *src = ptr;
	movw R20,R12
	rjmp L15
L14:
	.dbline 65
	.dbline 66
	movw R30,R20
	ldd R18,z+0
	movw R16,R10
	rcall _EEPROMwrite
	.dbline 67
	movw R24,R10
	adiw R24,1
	movw R10,R24
	.dbline 68
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 69
L15:
	.dbline 64
; 
; 	while (size--)
	movw R2,R22
	subi R22,1
	sbci R23,0
	tst R2
	brne L14
	tst R3
	brne L14
X1:
	.dbline -2
L13:
	rcall pop_gset4
	.dbline 0 ; func end
	ret
	.dbsym r src 20 pc
	.dbsym r size 22 I
	.dbsym r ptr 12 pV
	.dbsym r addr 10 I
	.dbend
