#include <iom8v.h>
#include <macros.h>
#include "var.h"
#include "SPI_MAX7221.h"
#include "TWI_DS1307.h"
#include "eeprom.h"

void VDs(unsigned char on_off);/// 
unsigned char keys(void);
void sets(void);
void wr_dec_data2DS1307(unsigned char addr, unsigned char min_val, unsigned char max_val);
void wr_inc_data2DS1307(unsigned char addr, unsigned char min_val, unsigned char max_val);
void exit_sets(void);
void update_alarm_1(void);
void update_alarm_2(void);
void read_eeprom_data(void);

void VDs(unsigned char on_off)/// 
{
 	if(on_off)
	{
	 	PORTD &= 0x3F;// VD2-3
		f_VDs |= 0x01;
	}
	else
	{
	 	PORTD |= 0xC0;// VD2-3
		f_VDs &= 0xFE;
	}
}

unsigned char keys(void)//  
{
 	unsigned char temp_i = 0;
	if(keys_count >= d_keys)//    
	{
		if(!(PIND&0x20)) temp_i |= 0x08;//  SB1(4)
		else if(!(PINC&0x02)) temp_i |= 0x04;//  SB2(3)
		 	 else if(!(PINC&0x04)) temp_i |= 0x02;//  SB3(2)
		 	  	  else if(!(PINC&0x08)) temp_i |= 0x01;//  SB4(1)
		if(temp_i) keys_count = 0;//    d_keys
	}
	return temp_i;
}

void sets(void)
{
 	unsigned char temp_i = 0, temp_j = 0, temp_k = 0;
	temp_i = keys();
	if(temp_i)
	{
	 	flags |= 0x02;
		if(temp_i&0x01)//   
		{
		 	st_but[s_st_but] = 1;
		}
		if(temp_i&0x02)//   
		{
		 	st_but[s_st_but] = 2;
		}
		if(temp_i&0x04)//   
		{
		 	st_but[s_st_but] = 3;
		}
		if(temp_i&0x08)//   
		{
			st_but[s_st_but] = 4;
		}
		s_st_but++;
	}
	else return;
	
	if(!s_st_but){
		exit_sets();
		return;
	}
//-------------------------   -------------------------
	for(temp_i = 1; temp_i < 5; temp_i++)
	{
		if(st_but[0] == temp_i)
		{
		 	for(temp_j = 0; temp_j < s_st_but; temp_j++)
			{
			 	if(st_but[temp_j] != temp_i)
				{
				 	break;
				}
			}
			break;
		}
	}
//-------------------------   -------------------------
	if(st_but[0] == 1)//  /
	{
	 	if(temp_j > 7)
		{
		 	exit_sets();
			return;
		}
		menu_st = temp_j;
		if(st_but[s_st_but - 1] == 2)//   
		{
		 	s_st_but--;
			if(menu_st == set_hours)
			{
			 	wr_dec_data2DS1307(addr_hours, 0, 23);
			}
			if(menu_st == set_mins)
			{
			 	wr_dec_data2DS1307(addr_mins, 0, 59);
			}
			if(menu_st == set_secs)
			{
				WR_DS1307(addr_secs, 0);
			}
			if(menu_st == set_date)
			{
			 	wr_dec_data2DS1307(addr_date, 1, 31);
			}
			if(menu_st == set_day)
			{
			 	wr_dec_data2DS1307(addr_day, 1, 7);
			}
			if(menu_st == set_mons)
			{
			 	wr_dec_data2DS1307(addr_mons, 1, 12);
			}
			if(menu_st == set_years)
			{
			 	wr_dec_data2DS1307(addr_years, 9, 29);
			}
			update_time();
		}
		if(st_but[s_st_but - 1] == 3)//   
		{
		 	s_st_but--;
		 	if(menu_st == set_hours)
			{
				wr_inc_data2DS1307(addr_hours, 0, 23);
			}
			if(menu_st == set_mins)
			{
			 	wr_inc_data2DS1307(addr_mins, 0, 59);
			}
			if(menu_st == set_secs)
			{
				WR_DS1307(addr_secs, 0);
			}
			if(menu_st == set_date)
			{
			 	wr_inc_data2DS1307(addr_date, 1, 31);
			}
			if(menu_st == set_day)
			{
			 	wr_inc_data2DS1307(addr_day, 1, 7);
			}
			if(menu_st == set_mons)
			{
			 	wr_inc_data2DS1307(addr_mons, 1, 12);
			}
			if(menu_st == set_years)
			{
			 	wr_inc_data2DS1307(addr_years, 9, 29);
			}
			update_time();
		}
		if(st_but[s_st_but - 1] == 4)//    -> 
		{
		 	exit_sets();
			return;
		}
	}
	if(st_but[0] == 2)//  
	{
	 	if(temp_j > 6)
		{
		 	exit_sets();
			return;
		}
	 	menu_st = temp_j + set_years;
		if(st_but[s_st_but - 1] == 1)//    -> 
		{
		 	exit_sets();
			return;
		}
		update_alarm_1();
		if(st_but[s_st_but - 1] == 3)//   
		{
		 	s_st_but--;
			if(menu_st == set_alarm_type)
			{
			 	if(type_alarm == alarm_type_off) type_alarm = alarm_type_sin;
				else type_alarm--;
			}
			if(menu_st == set_alarm_hours)
			{
			 	if(al_hour == 0) al_hour = 23;
				else al_hour--;
			}
			if(menu_st == set_alarm_mins)
			{
			 	if(al_min == 0) al_min = 59;
				else al_min--;
			}
			if(menu_st == set_alarm_date)
			{
			 	if(al_date == 1) al_date = 31;
				else al_date--;
			}
			if(menu_st == set_alarm_mons)
			{
			 	if(al_mon == 1) al_mon = 12;
				else al_mon--;
			}
			update_alarm_2();
			if(menu_st == set_alarm_num)
			{
			 	if(num_alarm == 0) num_alarm = 15;
				else num_alarm--;
			}
		}
		if(st_but[s_st_but - 1] == 4)//   
		{
		 	s_st_but--;
			if(menu_st == set_alarm_type)
			{
			 	if(type_alarm == alarm_type_sin) type_alarm = alarm_type_off;
				else type_alarm++;
			}
			if(menu_st == set_alarm_hours)
			{
			 	if(al_hour == 23) al_hour = 0;
				else al_hour++;
			}
			if(menu_st == set_alarm_mins)
			{
			 	if(al_min == 59) al_min = 0;
				else al_min++;
			}
			if(menu_st == set_alarm_date)
			{
			 	if(al_date == 31) al_date = 1;
				else al_date++;
			}
			if(menu_st == set_alarm_mons)
			{
			 	if(al_mon == 12) al_mon = 1;
				else al_mon++;
			}
			update_alarm_2();
			if(menu_st == set_alarm_num)
			{
			 	if(num_alarm == 15) num_alarm = 0;
				else num_alarm++;
			}
		}
	}
	if(st_but[0] == 3)
	{
		if(view == max_view) view = 0;
		else view++;
		EEPROM_WRITE((int)&EE_view, view);
		exit_sets();
	}
	if(st_but[0] == 4)
	{
	 	if(!f_disp_off) f_disp_off = 0x01;//    ->  
		else if(f_disp_off == 0x01) f_disp_off = 0x03;//   ->  
			 else if(f_disp_off == 0x03) f_disp_off = 0x02;//   ->  
			 	  else if(f_disp_off = 0x02) f_disp_off = 0x00;//    ->  
		exit_sets();
	}
}

void exit_sets(void)
{
 	s_st_but = 0;
	menu_st = set_none;
	flags &= 0xFD;
}

void wr_dec_data2DS1307(unsigned char addr, unsigned char min_val, unsigned char max_val)
{
 	unsigned char temp_i = 0, temp_j = 0, temp_k = 0;
	temp_i = RE_DS1307(addr);
	temp_j = (temp_i >> 4) * 10;
	temp_k = (temp_i&0x0F);
	temp_i = temp_k + temp_j;
	if(temp_i == min_val) temp_i = max_val;
	else temp_i--;
	temp_j = (temp_i / 10) << 4;
	temp_k = temp_i - ((temp_i / 10) * 10);
	temp_i = temp_j | temp_k;
	WR_DS1307(addr, temp_i);
}

void wr_inc_data2DS1307(unsigned char addr, unsigned char min_val, unsigned char max_val)
{
 	unsigned char temp_i = 0, temp_j = 0, temp_k = 0;
	temp_i = RE_DS1307(addr);
	temp_j = (temp_i >> 4) * 10;
	temp_k = (temp_i&0x0F);
	temp_i = temp_k + temp_j;
	if(temp_i == max_val) temp_i = min_val;
	else temp_i++;
	temp_j = (temp_i / 10) << 4;
	temp_k = temp_i - ((temp_i / 10) * 10);
	temp_i = temp_j | temp_k;
	WR_DS1307(addr, temp_i);
}
				
void update_alarm_1(void)//     
{
	al_mon = mas_mon_alarm[num_alarm];
	al_date = mas_date_alarm[num_alarm];
	al_hour = mas_hour_alarm[num_alarm];
	al_min = mas_min_alarm[num_alarm];
	type_alarm = mas_type_alarm[num_alarm];
}

void update_alarm_2(void)//  
{
//-------------       EEPROM------------
	mas_mon_alarm[num_alarm] = al_mon;
	mas_date_alarm[num_alarm] = al_date;
	mas_hour_alarm[num_alarm] = al_hour;
	mas_min_alarm[num_alarm] = al_min;
	mas_type_alarm[num_alarm] = type_alarm;
	EEPROM_WRITE((int)&EE_mon_alarm[num_alarm], al_mon);
	EEPROM_WRITE((int)&EE_date_alarm[num_alarm], al_date);
	EEPROM_WRITE((int)&EE_hour_alarm[num_alarm], al_hour);
	EEPROM_WRITE((int)&EE_min_alarm[num_alarm], al_min);
	EEPROM_WRITE((int)&EE_type_alarm[num_alarm], type_alarm);
//-------------       EEPROM------------
}

void read_eeprom_data()
{
 	unsigned char temp_i = 0;
//----------------------------------  EEPROM--------------------------------
	EEPROM_READ((int)&EE_len_alarm, len_alarm);
	EEPROM_READ((int)&EE_view, view);
	for(temp_i = 0; temp_i < 16; temp_i++)
	{
	 	EEPROM_READ((int)&EE_type_alarm[temp_i], mas_type_alarm[temp_i]);
		EEPROM_READ((int)&EE_hour_alarm[temp_i], mas_hour_alarm[temp_i]);
		EEPROM_READ((int)&EE_min_alarm[temp_i], mas_min_alarm[temp_i]);
		EEPROM_READ((int)&EE_date_alarm[temp_i], mas_date_alarm[temp_i]);
		EEPROM_READ((int)&EE_mon_alarm[temp_i], mas_mon_alarm[temp_i]);
	}
//----------------------------------  EEPROM--------------------------------
}